#include "hidrelay.h"

// Initial setup, ... Get the status of all the relays
HIDRELAY *hidrelay_find(unsigned int flags) {
    HIDRELAY *hidrelay_first, *hr;
    struct hid_device_info *hdi_first, *hdi_p;
    int relay_count;
//    char *product;
    unsigned short vendor_id  = 0x16c0;
    unsigned short product_id = 0x05df;

    hidrelay_first = NULL;

//    product = getenv("USBID");

    // Walk the vendor/product list
    hdi_first = hid_enumerate(vendor_id, product_id);
    for(hdi_p = hdi_first; hdi_p != NULL; hdi_p = hdi_p->next) {
        // USBrelay{n}
        relay_count = atol((const char *)&hdi_p->product_string[8]);
        if(relay_count == 0) {
            continue;
        }
        if(hidrelay_first == NULL) {
            hidrelay_first = hidrelay_fetch(NULL,hdi_p->path,relay_count,flags);
            if(hidrelay_first == NULL) {
                return(NULL);
            }
            hr = hidrelay_first;
        } else {
            hr->next = hidrelay_fetch(NULL,hdi_p->path,relay_count,flags);
            if(hr->next == NULL) {
                continue;
            }
            hr = hr->next;
        }
    }
    return(hidrelay_first);
}
