//
//
// Last Modified: 2022-12-29 16:18:45
//
#include "hidrelay.h"

#define NAME_COMMAND 0xfa
#define NAME_MAX_LENGTH 5

int hidrelay_name(HIDRELAY *hr, char *name) {
    HIDRELAY_COMMAND rc;
    hid_device *hd;
    int status;

    if(hr->hd != NULL) {
        hd = hr->hd;
    } else {
        hd = hid_open_path(hr->device_path);
    }
    memset(&rc,0,sizeof(rc));
    rc.n.command = NAME_COMMAND;
    strncpy(rc.n.name,name,NAME_MAX_LENGTH);
    status = hid_write(hd, (unsigned char *)&rc, sizeof(rc));
    if (status < 0) {
        fprintf(stderr,"FAILURE: %ls\n",hid_error(hd));
    }
    if(hr->hd == NULL) {
        hid_close(hd);
    }
    return(status);
}
