#include "hidrelay.h"

#define PAUSE_BETWEEN_SET 400000

int hidrelay_set(HIDRELAY *hr) {
    HIDRELAY_COMMAND rc;
    int ix,res,rval;
    hid_device *hd;

    rval = 1;
    memset(&rc,0,sizeof(rc));
    rc.c.report = 0x0;

    if(hr->hd != NULL) {
        hd = hr->hd;
    } else {
        hd = hid_open_path(hr->device_path);
    }
    for(ix = 0; ix < hr->relay_count; ix++) {
        if(hr->request[ix] != 0 && hr->state[ix] != hr->request[ix]) {
            rc.c.state = hr->request[ix];
            rc.c.relay = ix + 1;
            res = hid_write(hd, (unsigned char *)&rc, sizeof(rc));
            if(hr->last_error[ix] == NULL) {
                hr->last_error[ix] = malloc(HIDRELAY_LAST_ERROR_SIZE);
                memset(hr->last_error[ix],0,HIDRELAY_LAST_ERROR_SIZE);
            }
            if (res < 0) {
                sprintf(hr->last_error[ix]
                        ,"FAILURE: %d=%s\n%ls\n"
                        ,ix + 1
                        ,hr->request[ix] ? "ON" : "OFF"
                        ,hid_error(hd));
                rval = 0;
            } else {
                sprintf(hr->last_error[ix]
                        ,"SUCCESS:%d=%s\n"
                        ,ix + 1
                        ,hr->request[ix] ? "ON" : "OFF");
            }
            usleep(PAUSE_BETWEEN_SET);
        }
    }
    if(hr->hd == NULL) {
        hid_close(hd);
    }
    return(rval);
}
