//
//        Source: hidrelay_show.c
//         Title: Show the status of the given relay device
//
// Last Modified: 2022-12-29 14:30:54
//
#include "hidrelay.h"
int hidrelay_show(HIDRELAY *hr,int flag) {
    int ix;
    fprintf(stdout,"Relay ID: %s\n",hr->name);
    switch(flag) {
    case HIDRELAY_SHOW_REQUEST:
        fprintf(stdout,"  State Change Request:\n");
        break;
    case HIDRELAY_SHOW_STATE:
        fprintf(stdout,"  Current State:\n");
        break;
    }
    for(ix = 0; ix < hr->relay_count; ix++) {
        switch(flag) {
        case HIDRELAY_SHOW_REQUEST:
            fprintf(stdout,"    %2d: %-3s -> %s\n",ix + 1
                    ,hidrelay_status(hr->state[ix])
                    ,hidrelay_status(hr->request[ix]));
            break;
        case HIDRELAY_SHOW_STATE:
            fprintf(stdout,"    %d: %s\n",ix + 1,hidrelay_status(hr->state[ix]));
            break;
        }
    }
    return(0);
}
