/*----------------------------------------------------------------------
expand.c

Expand a string with enviromental variables in it.
----------------------------------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>
#include "local.h"

int expand(target, source, length)
char	*target, *source;
int length;
{
    char    *p;
    char    *varval;
    char    varname[512];
    int    i;
    int tix;

    length--;
    tix = 0;
    for(p = source; *p && tix < length;) {
        switch(*p) {
        case '\\':
            target[tix++] = *++p;
            ++p;
            break;
        case '$':
            ++p;
            for(i = 0; *p >= 'a' && *p <= 'z' ||
                   *p >= 'A' && *p <= 'Z' ||
                   *p == '_';) {
                varname[i++] = *p++;
                if(i > 510) return(0);
            }
            varname[i] = 0;
            varval = getenv(varname);
            if(varval != NULL) {
                while (*varval && tix < length) target[tix++] = *varval++ ;
            }
            break;
        default:
            target[tix++] = *p++;
            break;
        }
    }
    target[tix] = 0;
    return(0);
}
