/*

fdreadln.c - read line from file descriptor

*/

#include <fcntl.h>
#include <unistd.h>
#include "local.h"

#ifdef DEBUG
#undef DEBUG
#endif

#define DEBUG 0

#if (DEBUG > 0)
#include <stdio.h>
#endif

int	fdreadln(fd, line_buffer, file_buffer, bptr, bsize, limit)
int	fd;
char	*line_buffer;
char	*file_buffer;
int	*bptr;
int	*bsize;
int	limit;
{
	char	*p;

	if(*bsize == 0) {
		*bsize = read(fd, file_buffer, limit);
	}
	p = line_buffer;

	while(1) {
#if (DEBUG > 5)
		fprintf(stderr,"*bptr = %d *bsize=%d\n", *bptr, *bsize);
#endif
		while(*bptr >= *bsize) {
#if (DEBUG > 7)
			fprintf(stderr,"in while: *bptr = %d *bsize=%d\n", *bptr, *bsize);
#endif
			if(*bsize < limit) {
				*p = 0;
				return( (int)(-1 -(p - line_buffer)) );
			}
			*bptr = 0;
			*bsize = read(fd, file_buffer, limit);
		}
		if(file_buffer[*bptr] == 0 || file_buffer[*bptr] == '\n') {
			*p = 0;
			(*bptr)++;
#if (DEBUG > 7)
			fprintf(stderr,"EOL @ %s\n", line_buffer);
#endif
			return((int)(p - line_buffer));
		}
		if(file_buffer[*bptr] != '\r') *p++ = file_buffer[*bptr];
		(*bptr)++;
	}
}
