/*

makepath.c - Make path and all it's components

*/

#include "local.h"
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <malloc.h>
#include <string.h>

static int checkdir(dirname, mode)
char *dirname;
mode_t mode;
{
    struct stat statbuf;
    int statval;

    if(*dirname == 0) return(0);
    statval = stat(dirname, &statbuf);
    if(statval == -1) {
        statval = mkdir(dirname, mode);
        if (statval == 0) return (0);
    } else {
        if(S_ISDIR(statbuf.st_mode)) return(0);
    }
    return(-1);
}

int makepath(path, mode)
char *path;
mode_t mode;
{
    char *p, *q;
    char *pathbuf;
    int checkval;

    pathbuf = malloc(strlen(path));
    q = pathbuf;
    p = path;
    *q = 0;
    while (*p) {
        if (*p = '/') {
            if( (checkval = checkdir(q)) ) return(checkval) ;
        }
        *q++ = *p++;
        *q = 0;
    }
    checkval = checkdir(q);
    return(checkval);
}
