/*

by Keith Edwin Smith

This code is hereby released to the Public Domain


int	readline(f,buffer, length)
FILE	*f;
char	*buffer;
int	length;

Reads up to length characters from stream f into a \0 terminated buffer
pointed to by buffer.  Returns number of characters in buffer, negated
-1 if EOF reached. 

strips CR's out of the file (ascii text read only)

*/

/* function declaration is in local.h, ensure's they match */
#include "local.h"

int	readline(f, buffer, length)
FILE	*f;
char	*buffer;
int	length;
{
	int	cc;
	int	count;
	count = 0;
	while(1) {
		cc = fgetc(f);
		if(cc == EOF) {
			buffer[count] = 0;
			return( -(count + 1) );
		}
		if(cc == '\r') {
			continue;
		}
		if(cc == '\n') {
			buffer[count] = 0;
			return( count );
		}
		buffer[count++] = cc;
		if(count >= (length - 1) ) {
			buffer[count] = 0;
			return( count );
		}
	}
}
