/*
    strpack - Remove trailing spaces from a string
*/

#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include "local.h"

int strpack(s)
char    *s;
{
    int    l;

    if (s == NULL) {
        fprintf(stderr,"\007ERROR: strpack called with NULL argument");
        sleep(3);
        exit(255);
    }
    l = strlen(s);
    if(l == 0) return(0);
    if(l < 0 || l > 16384) {
#if 0
        fprintf(stderr,"strpack: l = %d **",l);
#endif
        exit(0);
    }
    while (--l >= 0 && s[l] <= ' ') s[l] = 0;
    return(0);
}

int strcvs(s, func)
char *s;
int func;
{
    int l, ix_in, ix_out;
    int last_char;

#if 0
    fprintf(stderr, "\r\ncvs(%s,%d)\r\n",s, func);
#endif
    if (s == NULL) {
        fprintf(stderr,"\007ERROR: strcvs called with NULL string");
        sleep(3);
        exit(255);
    }
    if ( func & CVS_TRAILING ) strpack(s);
    l = strlen(s);
    last_char = 0;
    for(ix_in = ix_out = 0; ix_in < l; ix_in++) {
#if 0
        fprintf(stderr,"check in = |%d| out = |%d|\r\n",
            ix_in, ix_out);
#endif
        if (
            (func & CVS_NON_PRINTABLE) &&
            (s[ix_in] < 32 || s[ix_in] > 126)
        ) s[ix_in] = ' ';
        if (
            (func & CVS_LEADING) &&
            ix_out == 0 &&
            s[ix_in] == ' '
        ) {
#if 0
            fprintf(stderr," Tossing leading space @ %d\n\r",ix_in);
#endif
            continue;
        }
        if (
            (func & CVS_MULTIPLE) &&
            (s[ix_in] == ' ' || s[ix_in] == '\t' )  &&
            last_char == ' '
        ) continue;
#if 0
        fprintf(stderr,"copy |%c| -> s[%d]\r\n",
            s[ix_in], ix_out);
#endif
        s[ix_out++] = s[ix_in];
        last_char = s[ix_in];
    }
    s[ix_out] = 0;
    if(func & CVS_LOWER) strlwr(s);
    if(func & CVS_UPPER) strupr(s);
#if 0
    fprintf(stderr, "cvsdone(%s)\r\n",s);
    sleep(3);
#endif
    return(ix_out);
}
