//
//        Source: current_timestamptz.c
//       Created: Tue Dec 20 16:02:25 2022
//            By: Keith Edwin Smith
//     Copyright: (c)2022 Keith Edwin Smith
//         Title: powermeter: Fill buffer with a PG style timestamp of the current time
//
// Last Modified: 2022-12-31 16:01:20
//

#include "panelmonitor.h"

//----------------------------------------------------------------------
// CURRENT_TIMESTAMPTZ
//----------------------------------------------------------------------
struct tm *current_timestamptz(char *buf, int buflen) {
    time_t t;
    struct tm *tmp;

    t = time(NULL);
    tmp = localtime(&t);
    if (tmp == NULL) {
        perror("localtime");
        exit(255);
    }
    if (strftime(buf,32,"%Y-%m-%d %H:%M:%S-0700", tmp) == 0) {
        fprintf(stderr, "strftime returned 0");
        exit(255);
    }
    return(tmp);
}
