//
//        Source: db_open.c
//       Created: Tue Dec 20 16:02:25 2022
//            By: Keith Edwin Smith
//     Copyright: (c)2022 Keith Edwin Smith
//         Title: powermeter: Open our database
//
// Last Modified: 2022-12-31 16:01:43
//

#include "panelmonitor.h"

//----------------------------------------------------------------------
// DB_OPEN
// Open our database
// FIXME: Hardcoded DB parms
//----------------------------------------------------------------------
PGconn *db_open(CONFIG_FILE_SECTION *cfg) {
    PGconn *dbh;
    char *server, *user, *password, *database;
    char connect_buf[256];

    server = config_value(cfg,"database","db_server");
    user = config_value(cfg,"database","db_user");
    password = config_value(cfg,"database","db_password");
    database = config_value(cfg,"database","db_database");
    sprintf(connect_buf,"host=%s user=%s password=%s dbname=%s"
            ,server,user,password,database
            );
    // Connect to the database
    dbh = PQconnectdb(connect_buf);
    if (PQstatus(dbh) == CONNECTION_BAD) {
        fprintf(stderr, "connection to database failed: %s\n",
                PQerrorMessage(dbh));
        exit(-1);
    }
    if(g.verbose) {
        int ver = PQserverVersion(dbh);
        printf("Server version: %d\n", ver);
    }
    return(dbh);
}
