/*    */
// Last Modified: 2023-01-04 21:30:42

#include "../hidrelay/hidrelay.h"

struct relay_struct {
    char *label;
    int threshold_on;
    int threshold_off;
    int activate;
    int override;
    int current_state;
    time_t last_change;
};
typedef struct relay_struct RELAY;

#ifdef RELAY_DATA
char *relay_activate_words[] = {
    "soft"
    ,"hard"
    ,NULL
};
char *relay_override_words[] = {
    "NONE"
    ,"ON"
    ,"OFF"
    ,NULL
};
#else
extern char *relay_activate_words[];
extern char *relay_override_words[];
#endif

#define RELAY_ACTIVATE_SOFT 0
#define RELAY_ACTIVATE_HARD 1
#define RELAY_ACTIVATE_NULL 2

#define RELAY_OVERRIDE_NONE 0
#define RELAY_OVERRIDE_ON 1
#define RELAY_OVERRIDE_OFF 2
#define RELAY_OVERRIDE_NULL 3

#define RELAY_STATE_OFF 0
#define RELAY_STATE_ON 1
#define RELAY_STATE_TIME_WAIT 2
