//
//        Source: sensor_calibrate.c
//       Created: Tue Dec 20 16:02:25 2022
//            By: Keith Edwin Smith
//     Copyright: (c)2022 Keith Edwin Smith
//         Title: powermeter: Supposedly calibrates the sensor
//
// Last Modified: 2022-12-31 16:03:40
//

#include "panelmonitor.h"

//----------------------------------------------------------------------
// SENSOR_CALIBRATE
// Sheet sez, 0xF8,0x41,0x37,0x21,CRC
// This does not pick a sensor?  Probably does nothing or fails
//----------------------------------------------------------------------
int sensor_calibrate(modbus_t *psensor, int sensor_id) {
    unsigned char request[8];
    int length,ix;
    uint8_t rsp[MODBUS_TCP_MAX_ADU_LENGTH];

    if(g.verbose) {
        fprintf(stderr,"Calibrating Sensor\n");
    }

    sensor_open(psensor,sensor_id);
    request[0] = 0xf8; // sensor_id?;
    request[1] = 0x41;
    request[2] = 0x37;
    request[3] = 0x21;
    length = modbus_send_raw_request(psensor, request, 4);
    modbus_receive_confirmation(psensor, rsp);
    if(g.verbose) {
        fprintf(stderr,"request returns = %d\n",length);
        fprintf(stderr,"length = %d Respose:\n",length);
        for(ix = 0; ix < MODBUS_TCP_MAX_ADU_LENGTH; ix++) {
            fprintf(stderr,"%02x ",rsp[ix]);
        }
        fprintf(stderr,"\n");
    }
    modbus_close(psensor);
}
