//
//        Source: sensor_open.c
//       Created: Tue Dec 20 16:02:25 2022
//            By: Keith Edwin Smith
//     Copyright: (c)2022 Keith Edwin Smith
//         Title: powermeter: open a connection to sensor_id
//
// Last Modified: 2023-01-06 19:29:25
//

#include "panelmonitor.h"

//----------------------------------------------------------------------
// SENSOR_OPEN
//----------------------------------------------------------------------
int sensor_open(modbus_t *psensor, int sensor_id) {
    if(psensor == NULL) {
        exit(255);
    }
    if (modbus_connect(psensor) == -1) {
        log_print(g.log,0, "Connection failed: %s\n", modbus_strerror(errno));
        return -1;
    }
    modbus_set_slave(psensor, sensor_id);
    modbus_set_response_timeout(psensor, 5, 0000000);
    return(1);
}
