//
//        Source: sensor_poll_all.c
//       Created: Tue Dec 20 16:02:25 2022
//            By: Keith Edwin Smith
//     Copyright: (c)2022 Keith Edwin Smith
//         Title: powermeter: Poll all sensors
//
// Last Modified: 2023-01-10 09:12:13
//

#include "panelmonitor.h"

//----------------------------------------------------------------------
// SENSOR_POLL_ALL
//----------------------------------------------------------------------
int sensor_poll_all(modbus_t *psensor, PGconn *dbh) {
    int ix;
    char stamp[32];
    struct tm *now;
    int amps;

    now = current_timestamptz(stamp,32);
    amps = 0;
    for(ix = 0; g.sensor_list[ix] != 0; ix++) {
        reset_check(now,RREQ_STATUS,psensor,g.sensor_list[ix]);
        sensor_poll_id(psensor,g.sensor_list[ix], stamp);
        // FIXME:  This needs to be in the sensor definition
        if(sv.sensor_id == 11 || sv.sensor_id == 12) {
            amps = amps < (int)sv.amps ? (int)sv.amps : amps;
        }
        if(sv.sensor_id != 0) {
            if(dbh != NULL) {
                add_table_entry(dbh,&sv);
                memset((void *)&sv,0,sizeof(sv));
            }
        }
        usleep(WAIT_NEXT_USEC); // Too fast will hang
    }
    relay_check(amps);
    // Update to next time if required
    reset_check(now,RREQ_UPDATE,NULL,0);
    return(amps);
}
