//
//        Source: usage.c
//       Created: Tue Dec 20 16:02:25 2022
//            By: Keith Edwin Smith
//     Copyright: (c)2022 Keith Edwin Smith
//         Title: powermeter: Print out some help
//
// Last Modified: 2022-12-31 16:05:35
//

#include "panelmonitor.h"

//----------------------------------------------------------------------
// USAGE
//----------------------------------------------------------------------
int usage(char *pgm) {
    fprintf(stderr
            ,"\n"
            "Usage: %s [flags]\n"
            "  Flags:\n"
            "  --calibrate     Calibration Request\n"
            "  --dev|--device {path}\n"
            "                  Path to RS-485 device\n"
            "  -d|--daemon     Start a polling loop\n"
            "  --help          This help text\n"
            "  --id {n}        No default, pull from sensor {n}\n"
            "  --interval {n}  Polling interval in seconds\n"
            "  --once          Poll sensors once\n"
            "  --reset {arg}\n"
            "                  now - One time right now\n"
            "                  daily, weekly, monthly, yearly\n"
            "  --reset-day {arg}\n"
            "                  Day of the week/month for energy reset\n"
            "                  0 = Sun 6 = Sat, or 1-31 day of month\n"
            "  --set-id {current} {new}\n"
            "                  Change ID of sensor {current} to {new}\n"
            "  --show          Show current configuration\n"
            "  -v|--verbose    Make Noise\n"
            "\n"
            ,pgm
            );
    exit(0);
}
